-- SOUNDPLAYER  - Simple Audio Management 
--
-- require "hump/class"

Soundplayer = Class(function(self,maxItems)
	self.maxItems = maxItems or 8
	self.itemCount = 0
	self.currentItems = {}
	self.loadedSoundData = {}
end)

function Soundplayer:update(dt)
	local remQueue = {}
	for i,v in ipairs(self.currentItems) do
		if v:isStopped() then
			table.insert(remQueue,i)
		end
 	end
	for i,v in ipairs(remQueue) do
		table.remove(self.currentItems, v)
		self.itemCount = self.itemCount - 1
	end
end

function Soundplayer:add(path, sndString)
	local snd = love.sound.newSoundData(path)
	self.loadedSoundData[sndString] = snd
end

function Soundplayer:play(sndString)
	if  self.itemCount < self.maxItems then
		local newSource = love.audio.newSource(self.loadedSoundData[sndString])
		table.insert(self.currentItems, newSource)
		love.audio.play(newSource)
		self.itemCount = self.itemCount + 1
	end
end