-- tutorial #2
-- the 3 golden love function, lua tables, keyboard input, draw circle




gameScreen = Gamestate.new()
function gameScreen:enter(current)
	if current == mainMenuScreen then
		
		
		-- high score yeah
		
		game = {}
		game.score = 0
		game.powerups = {}
		
		ptimer = 0 -- timer for the powerups
		burst = false
		doubleshot = false
		-- holds the current amoutn of enemys
		curEnemys = 0
		wave = 0
		
		love.mouse.setVisible(false)
		hero = {} -- new table for the hero
		hero.x = 160	-- x,y coordinates of the hero
		hero.y = 220
		hero.width = 30
		hero.height = 15
		hero.speed = 100
		hero.shots = {}
		enemys = {}
		bg = love.graphics.newImage("bg.png")
		newInvaders()
	end
	newPowerup()
end

function newPowerup()
	local pwu = {}
	pwu.x = math.random(0,320)
	pwu.y = 0
	pwu.color = {math.random(255),math.random(255),math.random(255),math.random(255)}
	pwu.type = math.random(3)
	table.insert(game.powerups, pwu)
end

function newInvaders()
	for k = 1,4 do
		-- look for the row
		local cells = {}
		for i=1,5 do
			cells[i] = {}
			for j=1,5 do
				-- 3x5 grid inspired by http://www.levitated.net/daily/levInvaderFractal.html
				cells[i][j] = math.random(0,1)
				if i>3 then -- mirror the shit
					cells[i][j] = cells[6-i][j]
				end
			end
		end
	
	
		for i=1,5 do
			enemy = {}
			enemy.width = 25
			enemy.height = 25
			enemy.cells = cells
			-- mirror the grid 3x5 grid inspired by http://www.levitated.net/daily/levInvaderFractal.html
	
		
	
			enemy.x = i * (enemy.width + 30) 
			enemy.y = -150 + (k-1)*35+enemy.height 
			table.insert(enemys, enemy)
			curEnemys = curEnemys + 1
		end
	end
end

function gameScreen:keypressed(key)
	if key == " " then
		shoot()
	elseif key == "escape" then
		Gamestate.switch(pauseMenuScreen)	
	end
end

function gameScreen:update(dt)
	-- keyboard actions for our hero
	if love.joystick.getAxis( 0 , 0 )==-1 then -- left
		hero.x = hero.x - hero.speed*dt
	elseif love.joystick.getAxis( 0 , 0 )==1 then --right
		hero.x = hero.x + hero.speed*dt
	end

	if love.keyboard.isDown("left") then
		hero.x = hero.x - hero.speed*dt
	elseif love.keyboard.isDown("right") then
		hero.x = hero.x + hero.speed*dt	
	end

	hero.x = math.min(math.max(0,hero.x),300)
	-- for debugging
	
	-- update those evil enemys
	for i,v in ipairs(enemys) do
		-- let them fall down slowly
		v.y = v.y + dt * (5 + 4*wave) --math.random(1,10)
		
		-- check for collision with ground
		if v.y > 220 then
			windeathScreen.state = "fail"
			Gamestate.switch(windeathScreen)
			soundplayer:play("dth")
		end
		
	end
	
	if burst then
		shoot()
	end
	-- update the powerups
	for i,v in ipairs(game.powerups) do
		v.y = v.y + dt * 50
	end
	if ptimer <1 and ptimer> 0 then
		hero.speed = 100
		burst = false
		doubleshot = false
	elseif ptimer>1 then
		ptimer = ptimer - dt
	end
	
	local remShots = {} -- remove those shots
	local remEnemy = {} -- remove those hit enemys
	for i,v in ipairs(hero.shots) do
		v.y = v.y - dt * 300
		
		-- collision detection
		for ii,vv in ipairs(enemys) do
			if CheckCollision(v.x,v.y,3,3,vv.x,vv.y,vv.width,vv.height) then
				table.insert(remEnemy, ii)
				table.insert(remShots, i)
				game.score = game.score + 1
				if game.score%10 == 0 then
					newPowerup()
				end
				curEnemys = curEnemys - 1
				soundplayer:play("exp")
			end
		end
		
		-- if outside screen
		if v.y <= 0 then
			table.insert(remShots, i)
		end
	end
	
	-- collision with powerups
	local remTable = {} 
	for i,v in ipairs(game.powerups) do
		if CheckCollision(hero.x,hero.y,hero.width,hero.height, v.x,v.y, 8,8) then
			-- type 1
			if v.type == 1 then
				hero.speed = hero.speed + 100
				ptimer = 10
			elseif v.type == 2 then
				burst = true
				ptimer = 4
			else
				doubleshot = true
				ptimer = 10
			end
			soundplayer:play("pwu")
			-- put in remove table
			table.insert(remTable, i)
		end
		if v.y > 220 then
			-- put in remove table
			table.insert(remTable, i)
		end
	end
	for i,v in ipairs(remTable) do
		table.remove(game.powerups,v)
	end
	
	for i,v in ipairs(remShots) do
		table.remove(hero.shots, v)
	end
	for i,v in ipairs(remEnemy) do
		table.remove(enemys, v)
	end
	
	if curEnemys==0 then
		newInvaders()
		wave = wave + 1
	end
	soundplayer:update(dt)
end

function shoot()
	if doubleshot then
		soundplayer:play("laz")
		local shot = {}
		shot.x = hero.x + hero.width
		shot.y = hero.y
		table.insert(hero.shots, shot)
		local shot = {}
		shot.x = hero.x 
		shot.y = hero.y
		table.insert(hero.shots, shot)
	else
		soundplayer:play("laz")
		local shot = {}
		shot.x = hero.x + hero.width/2
		shot.y = hero.y
		table.insert(hero.shots, shot)
	end
end

function gameScreen:joystickpressed( joystick, button )
	if button==1 then -- button == 'X'
		shoot()
	end
	if button==8 then -- button == 'HELP I'
		Gamestate.switch(pauseMenuScreen)	
	end
end

function gameScreen:joystickreleased( joystick, button )
	if button==6 or button==9 then
		love.event.push("q")
	end
end

function gameScreen:draw()
	-- let's draw some ground
--	love.graphics.setColor(255,255,255,255)
--	love.graphics.draw(bg,0,0)
	love.graphics.setColor(0,255,0,255)
	love.graphics.rectangle("fill", 0, 465, 800, 150)
	
	-- let's draw our hero
	love.graphics.setColor(255,255,0,255)
	love.graphics.rectangle("fill", hero.x, hero.y, hero.width, hero.height)
	
	-- let's draw our bullets
	for i,v in ipairs(hero.shots) do
		love.graphics.setColor(255,120,0,255)
		love.graphics.rectangle("fill", v.x, v.y, 3, 3)
	end
	-- let's draw our powerups
	for i,v in ipairs(game.powerups) do
		love.graphics.setColor(0,0,255,255)
		love.graphics.circle("fill", v.x, v.y, 8,16)
	end
	
	-- let's draw our enemys
	love.graphics.setColor(255,255,255,255)
	for i,v in ipairs(enemys) do
		--love.graphics.rectangle("fill", v.x, v.y, v.width, v.height)
		for ii=1,5 do
			for iii=1,5 do
				--love.graphics.point(v.x+ii*v.cells[ii*iii],v.y+iii*v.cells[ii*iii])
				if v.cells[ii][iii] == 1 then
					
					love.graphics.rectangle("fill", v.x+5*(ii-1)*v.cells[ii][iii],v.y+5*(iii-1)*v.cells[ii][iii], 4, 4)
				end
			end
		end
		
	end
	
	
	-- draw the score
	love.graphics.print(game.score, 5,5)

	
end

function CheckCollision(box1x, box1y, box1w, box1h, box2x, box2y, box2w, box2h)
    if box1x > box2x + box2w - 1 or -- Is box1 on the right side of box2?
       box1y > box2y + box2h - 1 or -- Is box1 under box2?
       box2x > box1x + box1w - 1 or -- Is box2 on the right side of box1?
       box2y > box1y + box1h - 1    -- Is b2 under b1?
    then
        return false                -- No collision. Yay!
    else
        return true                 -- Yes collision. Ouch!
    end
end
