--
--
--

-- helper: clears color to white
function clcol()
	love.graphics.setColor(255,255,255,255)
end

mainMenuScreen = Gamestate.new()
function mainMenuScreen:enter(current)
	
	love.mouse.setVisible(false)
	math.randomseed(os.time())
	math.random();math.random();math.random();math.random();

	--font = love.graphics.newImageFont("imagefont.png",
    --" abcdefghijklmnopqrstuvwxyz" ..
    --"ABCDEFGHIJKLMNOPQRSTUVWXYZ0" ..
    --"123456789.,!?-+/():;%&`'*#=[]\"")
	
	--font = love.graphics.newFont("AldotheApache.ttf")
	--love.graphics.setFont(font)
	love.graphics.setBackgroundColor(0,0,0,255)
	mainMenuScreen.state = "options"
	pit = false
end

function mainMenuScreen:nextState()
	if 	mainMenuScreen.state == "start" then
			mainMenuScreen.state = "options"
	elseif 	mainMenuScreen.state == "options" then
			mainMenuScreen.state = "end"
	elseif 	mainMenuScreen.state == "end" then
			mainMenuScreen.state = "start"
	else
			mainMenuScreen.state = "start"
	end
end

function mainMenuScreen:prevState()
	if 	mainMenuScreen.state == "start" then
			mainMenuScreen.state = "end"
	elseif 	mainMenuScreen.state == "options" then
			mainMenuScreen.state = "start"
	elseif 	mainMenuScreen.state == "end" then
			mainMenuScreen.state = "options"
	else
			mainMenuScreen.state = "start"
	end
end



function mainMenuScreen:update(dt)
	
	-- joystick
	if not pit and love.joystick.getAxis( 0 , 1 )==-1 then -- down
		mainMenuScreen:prevState()
		pit = true
		soundplayer:play("mv")
	elseif not pit and love.joystick.getAxis( 0 , 1 )==1 then --up
		mainMenuScreen:nextState()
		pit = true
		soundplayer:play("mv")
	elseif pit and love.joystick.getAxis(0,1)==0 then
		pit = false
	end
	soundplayer:update(dt)
end


function mainMenuScreen:keypressed(key)
	if key=="up" then
		mainMenuScreen:prevState()
		soundplayer:play("mv")
	elseif key == "down" then
		mainMenuScreen:nextState()
		soundplayer:play("mv")
	elseif key == "escape" then
		love.event.push("q")
	elseif key == "enter" or key == "return" then
		soundplayer:play("clk")
		if mainMenuScreen.state == "start" then
			soundplayer:play("clk")
			Gamestate.switch(gameScreen)
		elseif mainMenuScreen.state == "options" then

		else
			love.event.push('q')
		end
	end
end

function mainMenuScreen:joystickpressed( joystick, button )
	if button==1 or button==2 then -- button == 'X'
		if mainMenuScreen.state == "start" then
			soundplayer:play("clk")
			Gamestate.switch(gameScreen)
		elseif mainMenuScreen.state == "options" then

		else
			love.event.push('q')
		end
	end
end

function mainMenuScreen:joystickreleased( joystick, button )
	if button==6 or button==9 then
		love.event.push("q")
	end
end

function mainMenuScreen:draw()
	clcol()
	
	love.graphics.setColor(255,0,0,255)
	love.graphics.printf("EarthDefenders",320/2,-30+240/2,0,'center')
	love.graphics.printf("===========",320/2,-15+240/2,0,'center')
	if mainMenuScreen.state == "start" then
		love.graphics.setColor(255,255,255,255)
		love.graphics.circle("fill",-40+ 320/2,8 + 240/2, 4,16)
	end
	love.graphics.printf("START",320/2,240/2,0,'center')
	love.graphics.setColor(255,0,0,255)
	if mainMenuScreen.state == "options" then
		love.graphics.setColor(255,255,255,255)
		love.graphics.circle("fill",-50+ 320/2,15+8 + 240/2, 4,16)
	end
	love.graphics.printf("OPTIONS",320/2,15 + 240/2,0,'center')
	love.graphics.setColor(255,0,0,255)
	if mainMenuScreen.state == "end" then
		love.graphics.setColor(255,255,255,255)
		love.graphics.circle("fill",-25+ 320/2,30+8 + 240/2, 4,16)
	end
	love.graphics.printf("END",320/2,30+ 240/2,0,'center')
	--[[
	for k=1,3 do
		i = k
		if highscore[i] then
			love.graphics.setColor(255,255,255,70)
			love.graphics.print(highscore_name[i].." "..highscore[i], -30 + 320/2,0+i*10)
		end
	end
	--]]
end

pauseMenuScreen = Gamestate.new()
function pauseMenuScreen:enter()
	pauseMenuScreen.state = "start"
--	love.mouse.setVisible(true)
	pit = false
end


function pauseMenuScreen:nextState()
	if 	pauseMenuScreen.state == "start" then
			pauseMenuScreen.state = "options"
	elseif 	pauseMenuScreen.state == "options" then
			pauseMenuScreen.state = "end"
	elseif 	pauseMenuScreen.state == "end" then
			pauseMenuScreen.state = "start"
	else
			pauseMenuScreen.state = "start"
	end
end

function pauseMenuScreen:prevState()
	if 	pauseMenuScreen.state == "start" then
			pauseMenuScreen.state = "end"
	elseif 	pauseMenuScreen.state == "options" then
			pauseMenuScreen.state = "start"
	elseif 	pauseMenuScreen.state == "end" then
			pauseMenuScreen.state = "options"
	else
			pauseMenuScreen.state = "start"
	end
end



function pauseMenuScreen:keypressed(key)
	if key=="up" then
		pauseMenuScreen:prevState()
		soundplayer:play("mv")
	elseif key == "down" then
		pauseMenuScreen:nextState()
		soundplayer:play("mv")
	elseif key == "escape" then
		love.event.push("q")
	elseif key == "enter" or key == "return" then
		soundplayer:play("clk")
		if pauseMenuScreen.state == "start" then
			soundplayer:play("clk")
			Gamestate.switch(gameScreen)
		elseif pauseMenuScreen.state == "options" then

		else
			love.event.push('q')
		end
	end
end


function pauseMenuScreen:update(dt)
	-- joystick
	if not pit and love.joystick.getAxis( 0 , 1 )==-1 then -- down
		pauseMenuScreen:prevState()
		soundplayer:play("mv")
		pit = true
	elseif not pit and love.joystick.getAxis( 0 , 1 )==1 then --up
		pauseMenuScreen:nextState()
		soundplayer:play("mv")
		pit = true
	elseif pit and love.joystick.getAxis(0,1)==0 then
		pit = false
	end
end

function pauseMenuScreen:mousepressed(x,y,button)
	if pauseMenuScreen.state == "start" then
		Gamestate.switch(gameScreen)
	elseif pauseMenuScreen.state == "options" then
	
	else
		love.event.push('q')
	end
end

function pauseMenuScreen:joystickpressed( joystick, button )
	if button==1 or button==2 then -- button == 'X'
		if pauseMenuScreen.state == "start" then
			soundplayer:play("clk")
			Gamestate.switch(gameScreen)
		elseif pauseMenuScreen.state == "options" then
			soundplayer:play("clk")
		else
			love.event.push('q')
		end
	end
end

function pauseMenuScreen:draw()
	gameScreen:draw()
	love.graphics.setColor(0,0,0,100)
	love.graphics.rectangle("fill",0,0,320,240)
	clcol()
	
	love.graphics.setColor(255,0,0,255)
	love.graphics.printf("PAUSE",320/2,-30+240/2,0,'center')
	love.graphics.printf("===========",320/2,-15+240/2,0,'center')
	if pauseMenuScreen.state == "start" then
		love.graphics.setColor(255,255,255,255)
		love.graphics.circle("fill",-40+ 320/2,8 + 240/2, 4,16)
	end
	love.graphics.printf("CONTINUE",320/2,240/2,0,'center')
	love.graphics.setColor(255,0,0,255)
	if pauseMenuScreen.state == "options" then
		love.graphics.setColor(255,255,255,255)
		love.graphics.circle("fill",-50+ 320/2,15+8 + 240/2, 4,16)
	end
	love.graphics.printf("OPTIONS",320/2,15 + 240/2,0,'center')
	love.graphics.setColor(255,0,0,255)
	if pauseMenuScreen.state == "end" then
		love.graphics.setColor(255,255,255,255)
		love.graphics.circle("fill",-25+ 320/2,30+8 + 240/2, 4,16)
	end
	love.graphics.printf("END",320/2,30+ 240/2,0,'center')
end

windeathScreen = Gamestate.new()
windeathScreen.state = "fail"
windeathScreen.count = 0
function windeathScreen:enter()
	windeathScreen.count = 0
	--highscore_add(game.score, "Ich")
	--highscore_write("highscore.txt")
end
function windeathScreen:update(dt)
	windeathScreen.count=windeathScreen.count+dt
end
function windeathScreen:draw()
	gameScreen:draw()
	
	if windeathScreen.state == "win" then -- actually never going to happen
		love.graphics.setColor(255,255,255,80)
		love.graphics.rectangle("fill",0,0,320,240)
		clcol()
		love.graphics.setColor(255,255,0,255)
		love.graphics.printf("YOU WIN",320/2,-30+240/2,0,'center')
		love.graphics.printf("[ANY KEY]",320/2,50 + 240/2,0,'center')
	else
		love.graphics.setColor(255,0,0,180)
		love.graphics.rectangle("fill",0,0,320,240)
		clcol()
		love.graphics.setColor(255,255,255,255)
		love.graphics.printf("YOU FAILED",320/2,-30+240/2,0,'center')
		love.graphics.printf("SCORE: "..game.score,320/2,50 + 240/2,0,'center')
	end
	love.graphics.setColor(255,255,255,255)
	if (2-windeathScreen.count>=0) then
		love.graphics.printf(math.ceil(2-windeathScreen.count), 300, 5,0,'center')
	end
end

function windeathScreen:joystickpressed( joystick, button )
	--if button==1 then -- button == 'X'
	
	-- you have to press 2 times to continue
	if windeathScreen.count>2 then
			Gamestate.switch(mainMenuScreen)
	else
		--windeathScreen.count=windeathScreen.count+1
	end
	--end
end

function windeathScreen:keypressed(key)
	Gamestate.switch(mainMenuScreen)
	gameScreen.running = false
end
